* This file computes education expenses

version 8.2
clear
set more off
set mem 200m

log using education2005, replace

use "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005\educationA_cl", clear
rename m2a_q00 code
save "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\educationA_cl.dta", replace
drop _all

use "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005\educationB_cl", clear
rename m2b_q00 code
save "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\educationB_cl.dta", replace
drop _all

use "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005\educationC_cl",clear
rename m2c_q00 code
save "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\educationC_cl.dta", replace
drop _all

use "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\educationA_cl", clear
sort hhid code
merge hhid code using "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\educationB_cl.dta"
tab _merge
drop _merge
sort hhid code
merge hhid code using "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\educationC_cl.dta"
tab _merge
drop _merge
sort hhid code
save "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\education_cl", replace
drop _all

use "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\education_cl", clear
* the monthly minimum wage is 108,000 leks (old), assuming 22 days working days per month and 8 hours of work per day, a hour of work is worth about 614 leks.
* This is used to impute the value of hours of service given as form of payment to schools.

* Correcting for mistakes in hhid coding.

replace hhid=509 if hhid==505
replace hhid=1502 if hhid==1505
replace hhid=2310 if hhid==2309
replace hhid=6902 if hhid==6901
replace hhid=8708 if hhid==8709
replace hhid=9308 if hhid==9309
replace hhid=16109 if hhid==16110
replace hhid=18210 if hhid==18211
replace hhid=23007 if hhid==23001
replace hhid=26009 if hhid==26010
replace hhid=26509 if hhid==26510
replace hhid=34210 if hhid==34206
replace hhid=34409 if hhid==34402
replace hhid=37507 if hhid==37506
replace hhid=41609 if hhid==41608
replace hhid=43211 if hhid==43201
replace hhid=44506 if hhid==44505
replace hhid=46411 if hhid==46410

* Pre-school
gen typep=m2a_q03
label val typep M2A_Q03
egen typep_mx=max(typep), by(hhid)
egen typep_mn=min(typep), by(hhid)
gen pservice=614*m2a_q09
tab m2a_q05, nola miss
tab m2a_q07
tab pservice
egen preschool=rsum(m2a_q05 m2a_q07 pservice)
rename m2a_q05 pfee
rename m2a_q07 pgift
replace preschool=preschool
gen npresch=1 if m2a_q01==1
table typep, c(m preschool med preschool n preschool max preschool)

* School
gen type=m2b_q18
label val type M2B_Q18
egen type_mx=max(type), by(hhid)
egen type_mn=min(type), by(hhid)
gen transport=m2b_q25
tab transport
egen total=rsum(m2b_q29-m2b_q36)
rename m2b_q29 fee
rename m2b_q30 uniform
rename m2b_q31 textbook
rename m2b_q32 suptextbook
rename m2b_q33 material
rename m2b_q34 lodging
rename m2b_q35 excursion
rename m2b_q36 othered

gen totall=m2b_q37 
recode total 0=.
recode totall 0=.
sum total totall
tab totall if total==.
count if totall!=. & total==.
count if totall==. & total!=.
count if totall>total & total!=. 
count if totall<total & total!=. 
list totall total fee-othered if totall<total & total!=.
replace totall=total if totall<total & total!=.
count if totall==. & transport!=.

gen tutor=m2b_q44
gen gift=m2b_q46
gen service=m2b_q48*614
replace transport=transport*9
replace tutor=tutor*9
egen eduexp=rsum(totall transport tutor gift service)


*Generating a variable for educational expenditures as in 2002, excluding the components of excursion and suplementary textbook expenses.
egen total02=rsum(fee uniform textbook material lodging)
egen suptextexcurs=rsum(suptextbook excursion)
recode suptextexcurs .=0
gen eduexp02 = eduexp-suptextexcurs

*Generating a variable for educational expenditures in 2005, including preschool
egen eduexppre= rsum(eduexp02 preschool)

gen level=m2b_q16 
lab val level M2B_Q16
gen grade=m2b_q17 
lab val grade M2B_Q17

tab level type if eduexp>=50000
recode eduexp 0=. if level==. 
recode eduexp02 0=. if level==.
recode eduexppre 0=. if level==.
tab level if eduexp==0
tab level if eduexp02==0
tab level if eduexppre==0
table level, c(m eduexp med eduexp n eduexp)
table level, c(m eduexp02 med eduexp02 n eduexp02)
table level, c(m eduexppre med eduexppre n eduexppre)
table type, c(m eduexp med eduexp n eduexp)
table type, c(m eduexp02 med eduexp02 n eduexp02)
table type, c(m eduexppre med eduexppre n eduexppre)
gen nsch=1 if m2b_q09==1
keep npresch preschool pfee pgift pservice nsch transport fee uniform textbook suptextbook material lodging excursion othered suptextexcurs totall tutor gift service totall eduexp eduexp02 eduexppre total02 grade level typep typep_mx typep_mn type type_mx type_mn hhid
count if npresch==. & preschool>0 & preschool!=.
count if nsch==. & eduexp>0 & eduexp!=.
count if npresch==. & nsch==.
count if npresch==. & nsch==. & (preschool==0 | preschool==.) & (eduexp==0 | eduexp==.)
drop if npresch==. & nsch==.

for x in var pfee pgift pservice  preschool: replace x=x*(9/12)
for x in var transport fee uniform textbook suptextbook material lodging excursion othered tutor gift service suptextexcurs eduexp total02 eduexp02 eduexppre totall: replace x=x/12

sort hhid
save "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 padata\eduexp", replace

collapse (sum) pfee pgift pservice  preschool  transport fee uniform textbook suptextbook material lodging excursion othered tutor gift service suptextexcurs eduexp total02 eduexp02 eduexppre (mean) totall, by(hhid)

label var eduexp "Monthly Educational Expense in 2005"
label var eduexp02 "Monthly Educational Expense as in 2002, without excursion and suplementary textbook"
label var eduexppre "Monthly Educational Expense in 2005 as in 2002, including preschool"
sort hhid
save "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 padata\eduexp_short", replace
drop _all
log close

