* This file computes nonfood expenses

version 8.2
clear 
set more off
set mem 100m
log using nonfoodexpenditure2005,replace

use "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005\non_food_expendituresB_cl", clear
* codebook
rename m0_q00 psu
keep if m12b_q02==1
rename m12b_q00 code
tab code, nolab
gen nfood=m12b_q03/6
table code, contents(mean m12b_q03 med m12b_q03 min m12b_q03 max m12b_q03 n m12b_q03)
keep psu hhid code nfood
sort hhid code
save "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\temp1.dta", replace


use "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005\non_food_expendituresC_cl", clear
* codebook
rename m0_q00 psu
keep if m12c_q02==1
rename m12c_q00 code
tab code, nolab
gen nfood=m12c_q03/12
table code, c(m m12c_q03 med m12c_q03 min m12c_q03 max m12c_q03 n m12c_q03)
keep psu hhid code nfood
sort hhid code
save "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\temp2.dta", replace


use "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005\non_food_expendituresA_cl", clear
* codebook
rename m0_q00 psu
keep if m12a_q02==1
rename m12a_q00 code
tab code, nolab
gen nfood=m12a_q03
table code, contents(mean m12a_q03 med m12a_q03 min m12a_q03 max m12a_q03 n m12a_q03)
keep psu hhid code nfood
sort hhid code

merge hhid code using "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\temp1.dta"
tab _merge
drop _merge
sort hhid code
merge hhid code using "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\temp2.dta"
tab _merge
drop _merge

* Correcting error codings in hhid

replace hhid=509 if hhid==505
replace hhid=1502 if hhid==1505
replace hhid=2310 if hhid==2309
replace hhid=6902 if hhid==6901
replace hhid=8708 if hhid==8709
replace hhid=9308 if hhid==9309
replace hhid=16109 if hhid==16110
replace hhid=18210 if hhid==18211
replace hhid=23007 if hhid==23001
replace hhid=26009 if hhid==26010
replace hhid=26509 if hhid==26510
replace hhid=34210 if hhid==34206
replace hhid=34409 if hhid==34402
replace hhid=37507 if hhid==37506
replace hhid=41609 if hhid==41608
replace hhid=43211 if hhid==43201
replace hhid=44506 if hhid==44505
replace hhid=46411 if hhid==46410

gen subgroup=1 if (code>=1 & code<=4) | code==6
replace subgroup=2 if code==7 | code==8 | code==41
replace subgroup=3 if code==11 | code==14 | (code>=29 & code<=31) | code==40
replace subgroup=4 if code==12 | code==13 
replace subgroup=5 if code==5 | code==9 |code==32 | code==33
replace subgroup=6 if (code>=16 & code<=23)
replace subgroup=7 if code>=37 & code<=39 
replace subgroup=8 if code>=24 & code<=28
replace subgroup=9 if code==45 | code==46 
replace subgroup=10 if code==10 | code==42 | code==43
replace subgroup=11 if code==15 | code==34 | code==35 | code==36 | (code>=47 & code<=51) | code==44

label def subgroup 1 "cleaning"
label def subgroup 2 "transport", add
label def subgroup 3 "hobby", add
label def subgroup 4 "alcohol", add
label def subgroup 5 "services", add
label def subgroup 6 "clothing", add
label def subgroup 7 "personal", add
label def subgroup 8 "houseart", add
label def subgroup 9 "ceremonies", add
label def subgroup 10 "other", add
label def subgroup 11 "additional", add

sort hhid code
save "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 padata\nfood", replace

* this file will be used to check outliers with the "budget share method"
table code, c(m nfood max nfood n nfood)

collapse (sum) nfood, by(hhid subgroup)

gen sub1=nfood if subgroup==1
gen sub2=nfood if subgroup==2
gen sub3=nfood if subgroup==3
gen sub4=nfood if subgroup==4
gen sub5=nfood if subgroup==5
gen sub6=nfood if subgroup==6
gen sub7=nfood if subgroup==7
gen sub8=nfood if subgroup==8
gen sub9=nfood if subgroup==9
gen sub10=nfood if subgroup==10
gen sub11=nfood if subgroup==11

collapse (sum) sub1-sub11, by(hhid)
sort hhid
* Generating total non-food expenditure for each household.
*egen totnfood= rsum(sub1 - sub11)
*label var totnfood "total household non-food expenditure"
label var sub1 "non-food expenditure on cleaning"
label var sub2 "non-food expenditure on transport"
label var sub3 "non-food expenditure on hobby"
label var sub4 "non-food expenditure on vice"
label var sub5 "non-food expenditure on clothing"
label var sub6 "non-food expenditure on personal"
label var sub7 "non-food expenditure on houseart"
label var sub8 "non-food expenditure on gifts"
label var sub9 "non-food expenditure on services"
label var sub10 "non-food expenditure on other"
label var sub11 "non-food expenditure on items either newly included in 2005 or not included in 2002 calculations"

save "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 padata\nfoodexp", replace

gen year=2005
keep hhid sub1 sub2 sub3 sub4 sub5 sub6 sub7 sub8 sub9 sub10 sub11 year
save "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 padata\nfoodexpappend", replace
drop _all
log close

*** this file should be merged with the rest of consumption and shares and values should be checked




