*** This file computes utilities (water, electricity, gas, telephone and other)

version 8.2
clear
set more off
*set matsize 700
set mem 200m

/* ************************************** */
/* ****           WATER            ****** */
/* ************************************** */

log using utilitiesjm, replace

use "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 padata\hhrosterjm.dta", clear
gen hhsize=1
collapse (sum) hhsize, by(hhid)
sort hhid
save "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\basejm.dta", replace


use "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005\dwellingC1_cl.dta", clear
rename m0_q00 psu
label var psu "PSU"
rename m0_q01 hh
label var hh "household identifier"
rename m13c1_q1a itemdescription
drop itemdescription
rename m13c1_q1b itemcode
label var itemcode "item code"
rename m13c1_q1c numitems
label var numitems "number of items"

sort hhid itemcode  
reshape wide  numitems, i(hhid) j(itemcode)
save "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\dwellingC1_cl.dta", replace

use "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005\dwellingC2_cl.dta", clear
rename m0_q00 psu
label var psu "PSU"
rename m0_q01 hh
label var hh "household identifier"
rename m13c2_q00 liner
label var liner "liner"
rename m13c2_q2a itemdescription
drop itemdescription
rename m13c2_q2b itemcode
label var itemcode "item code"
rename m13c2_q03 year
label var year " years of acquisition"
rename m13c2_q04 purchase
label var purchase "purchase/gift"
rename m13c2_q05 amount
label var amount "amount"

sort hhid itemcode
egen meanctv=mean(amount) if itemcode==101, by(hhid)
egen meanbtv=mean(amount) if itemcode==102, by(hhid)
replace meanctv=meanbtv if itemcode==102
drop meanbtv

egen meanvideo=mean(amount) if itemcode==103, by(hhid)
replace meanctv=meanvideo if itemcode==103
drop meanvideo

egen meantape=mean(amount) if itemcode==104, by(hhid)
replace meanctv=meantape if itemcode==104
drop meantape

egen meancamera=mean(amount) if itemcode==105, by(hhid)
replace meanctv=meancamera if itemcode==105
drop meancamera

egen meanfridge=mean(amount) if itemcode==106, by(hhid)
replace meanctv=meanfridge if itemcode==106
drop meanfridge

egen meanfreezer=mean(amount) if itemcode==107, by(hhid)
replace meanctv=meanfreezer if itemcode==107
drop meanfreezer

egen meanwashmch=mean(amount) if itemcode==108, by(hhid)
replace meanctv=meanwashmch if itemcode==108
drop meanwashmch

egen meandishwasher=mean(amount) if itemcode==109, by(hhid)
replace meanctv=meandishwasher if itemcode==109
drop meandishwasher

egen meanelecstove=mean(amount) if itemcode==110, by(hhid)
replace meanctv=meanelecstove if itemcode==110
drop meanelecstove

egen meankerosenestv=mean(amount) if itemcode==111, by(hhid)
replace meanctv=meankerosenestv if itemcode==111
drop meankerosenestv

egen meanwoodstv=mean(amount) if itemcode==112, by(hhid)
replace meanctv=meanwoodstv if itemcode==112
drop meanwoodstv

egen meanradiator=mean(amount) if itemcode==113, by(hhid)
replace meanctv=meanradiator if itemcode==113
drop meanradiator

egen meangenerator=mean(amount) if itemcode==114, by(hhid)
replace meanctv=meangenerator if itemcode==114
drop meangenerator

egen meansewingmch=mean(amount) if itemcode==115, by(hhid)
replace meanctv=meansewingmch if itemcode==115
drop meansewingmch

egen meanconditioner=mean(amount) if itemcode==116, by(hhid)
replace meanctv=meanconditioner if itemcode==116
drop meanconditioner

egen meanwbroiler=mean(amount) if itemcode==117, by(hhid)
replace meanctv=meanwbroiler if itemcode==117
drop meanwbroiler

egen meancomputer=mean(amount) if itemcode==118, by(hhid)
replace meanctv=meancomputer if itemcode==118
drop meancomputer

egen meansatelite=mean(amount) if itemcode==119, by(hhid)
replace meanctv=meansatelite if itemcode==119
drop meansatelite

egen meanbicycle=mean(amount) if itemcode==120, by(hhid)
replace meanctv=meanbicycle if itemcode==120
drop meanbicycle

egen meanmotorcycle=mean(amount) if itemcode==121, by(hhid)
replace meanctv=meanmotorcycle if itemcode==121
drop meanmotorcycle

egen meancar=mean(amount) if itemcode==122, by(hhid)
replace meanctv=meancar if itemcode==122
drop meancar

egen meantruck=mean(amount) if itemcode==123, by(hhid)
replace meanctv=meantruck if itemcode==123
drop meantruck

egen meandumbtruck=mean(amount) if itemcode==124, by(hhid)
replace meanctv=meandumbtruck if itemcode==124
drop meandumbtruck

egen meanmicrowave=mean(amount) if itemcode==125, by(hhid)
replace meanctv=meanmicrowave if itemcode==125
drop meanmicrowave

rename meanctv meanamount
label var meanamount "mean of amounts"

egen meanyctv=mean(year) if itemcode==101, by(hhid)
egen meanybtv=mean(year) if itemcode==102, by(hhid)
replace meanyctv=meanybtv if itemcode==102
drop meanybtv

egen meanyvideo=mean(year) if itemcode==103, by(hhid)
replace meanyctv=meanyvideo if itemcode==103
drop meanyvideo

egen meanytape=mean(year) if itemcode==104, by(hhid)
replace meanyctv=meanytape if itemcode==104
drop meanytape

egen meanycamera=mean(year) if itemcode==105, by(hhid)
replace meanyctv=meanycamera if itemcode==105
drop meanycamera

egen meanyfridge=mean(year) if itemcode==106, by(hhid)
replace meanyctv=meanyfridge if itemcode==106
drop meanyfridge

egen meanyfreezer=mean(year) if itemcode==107, by(hhid)
replace meanyctv=meanyfreezer if itemcode==107
drop meanyfreezer

egen meanywashmch=mean(year) if itemcode==108, by(hhid)
replace meanyctv=meanywashmch if itemcode==108
drop meanywashmch

egen meanydishwasher=mean(year) if itemcode==109, by(hhid)
replace meanyctv=meanydishwasher if itemcode==109
drop meanydishwasher

egen meanyelecstove=mean(year) if itemcode==110, by(hhid)
replace meanyctv=meanyelecstove if itemcode==110
drop meanyelecstove

egen meanykerosenestv=mean(year) if itemcode==111, by(hhid)
replace meanyctv=meanykerosenestv if itemcode==111
drop meanykerosenestv

egen meanywoodstv=mean(year) if itemcode==112, by(hhid)
replace meanyctv=meanywoodstv if itemcode==112
drop meanywoodstv

egen meanyradiator=mean(year) if itemcode==113, by(hhid)
replace meanyctv=meanyradiator if itemcode==113
drop meanyradiator

egen meanygenerator=mean(year) if itemcode==114, by(hhid)
replace meanyctv=meanygenerator if itemcode==114
drop meanygenerator

egen meanysewingmch=mean(year) if itemcode==115, by(hhid)
replace meanyctv=meanysewingmch if itemcode==115
drop meanysewingmch

egen meanyconditioner=mean(year) if itemcode==116, by(hhid)
replace meanyctv=meanyconditioner if itemcode==116
drop meanyconditioner

egen meanywbroiler=mean(year) if itemcode==117, by(hhid)
replace meanyctv=meanywbroiler if itemcode==117
drop meanywbroiler

egen meanycomputer=mean(year) if itemcode==118, by(hhid)
replace meanyctv=meanycomputer if itemcode==118
drop meanycomputer

egen meanysatelite=mean(year) if itemcode==119, by(hhid)
replace meanyctv=meanysatelite if itemcode==119
drop meanysatelite

egen meanybicycle=mean(year) if itemcode==120, by(hhid)
replace meanyctv=meanybicycle if itemcode==120
drop meanybicycle

egen meanymotorcycle=mean(year) if itemcode==121, by(hhid)
replace meanyctv=meanymotorcycle if itemcode==121
drop meanymotorcycle

egen meanycar=mean(year) if itemcode==122, by(hhid)
replace meanyctv=meanycar if itemcode==122
drop meanycar

egen meanytruck=mean(year) if itemcode==123, by(hhid)
replace meanyctv=meanytruck if itemcode==123
drop meanytruck

egen meanydumbtruck=mean(year) if itemcode==124, by(hhid)
replace meanyctv=meanydumbtruck if itemcode==124
drop meanydumbtruck

egen meanymicrowave=mean(year) if itemcode==125, by(hhid)
replace meanyctv=meanymicrowave if itemcode==125
drop meanymicrowave

rename meanyctv meanyear
label var meanyear "mean of years of acquisition"

gen dropme=1 if meanamount==meanamount[_n-1] & itemcode==itemcode[_n-1]
drop if dropme==1

drop year
drop amount
drop liner

reshape wide meanamount meanyear purchase, i(hhid) j(itemcode)
sort hhid 
save "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\dwellingC2_cl.dta", replace

use "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005\dwellingC3_cl.dta", clear
rename m0_q00 psu
label var psu "PSU"
rename m13c3_q6b itemcode
label var itemcode "item code"
rename m0_q01 hh
label var hh "household identifier"
rename m13c3_q6c ownsitem
label var ownsitem "owns item"

sort hhid itemcode
reshape wide ownsitem, i(hhid) j(itemcode) 
save "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\dwellingC3_cl.dta", replace

use "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\dwellingC3_cl.dta", clear
sort hhid   
merge hhid using "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\dwellingC2_cl.dta"
tab _merge
drop _merge
sort hhid  
merge hhid using "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\dwellingC1_cl.dta"
tab _merge
drop _merge
sort hhid 
save "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\dwellingC_cljm.dta", replace


use "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005\communication_mobile_cl.dta", clear
sort hhid
* set bill equal to zero for those for whom employer pays and use phone only for business
replace m3_q14=0 if m3_q12==2 & m3_q15==2
collapse (sum) m3_q14, by(hhid)
save "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\communication_mobile_cljm.dta", replace



use "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005\dwellingA_cl.dta", clear
sort hhid
merge hhid using "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005\dwellingB_cl.dta"
tab _merge
drop _merge
sort hhid
merge hhid using "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\dwellingC_cljm.dta"
tab _merge
drop _merge

sort hhid
merge hhid using "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\communication_mobile_cljm.dta"
tab _merge
drop _merge
sort hhid 
save "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\dwelling_cljm.dta", replace


use "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\dwelling_cljm.dta", clear
sort hhid 
merge hhid using "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\JMbase.dta"
tab _merge
drop _merge
sort hhid 
merge hhid using "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\basejm.dta"
tab _merge
drop _merge
sort hhid
* did not use the section of arrears since the 2005 questionaire did not ask for them
* we do not have reference period for arrears
* recoding the winter and summer amounts as missing when they were reported as "Amount" 
recode  m13b_q10a1 0=.
recode  m13b_q10a2 0=.
count if m13b_q10a1==m13b_q10a2
count if m13b_q10a1!=. & m13b_q10a2==.
replace m13b_q10a2=m13b_q10a1 if m13b_q10a1!=. & m13b_q10a2==.
count if m13b_q10a1==. & m13b_q10a2!=. 
sum m13b_q10a1 m13b_q10a2, d	
count if m13b_q10a1==m13b_q10a2
egen waterb=rmean(m13b_q10a1 m13b_q10a2)
tab m13b_q01 if waterb!=.

tab m13b_q01 urbrur
tab m13b_q01 urbrur if waterb!=.

tab m13b_q01

gen pcwater=waterb/hhsize

* When the household receives running water theoretically this should be paid monthly and with a fixed amount per capita, this amount varies in each city

* verify the relationship between household size and water bill 
xi: reg waterb hhsize i.district*i.urbrur if m13b_q01==1
xi: reg waterb hhsize i.district*i.urbrur if m13b_q01==2

* there is a strong and clear relationship between water bill and household size in the case of water inside, less if water outside

* we check whether there are differences between households receiving piped water inside or outside
table district urbrur if m13b_q01==1, c(m pcwater)
table district urbrur if m13b_q01==2, c(m pcwater)

* ask Teranda: both households receiving water outside and inside should pay the same


* running water inside
table district if urbrur==1 & m13b_q01==1, c(median pcwater sd pcwater n pcwater) row
table district if urbrur==2 & m13b_q01==1, c(median pcwater sd pcwater n pcwater) row


* running water outside
table district if urbrur==1 & m13b_q01==2, c(median pcwater sd pcwater n pcwater)
table district if urbrur==2 & m13b_q01==2, c(median pcwater sd pcwater n pcwater)

* we can use the median values to impute water costs for households who receive running water, but don't pay

gen waterbill=waterb

egen medpcwat=median(pcwater) if m13b_q01==1 | m13b_q01==2, by(district urbrur)

replace waterb=hhsize*medpcwat if m13b_q01==1 | m13b_q01==2

tab waterb urbrur if m13b_q01>2
keep hhid waterb
sort hhid
save "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\water.dta", replace


**************************************
*****                            *****
*****         Electricity        *****
*****                            *****
**************************************

use "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 padata\hhrosterjm.dta", clear
gen hhsize=1
collapse (sum) hhsize, by(hhid)
sort hhid
save "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\basejm.dta", replace


use "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\dwelling_cljm", clear
sort hhid
merge hhid using "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\basejm.dta"
tab _merge
drop _merge
sort hhid
merge hhid using "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\JMbase.dta"
tab _merge
drop _merge

*** we can run a regression

* quantity, type of use, household size

gen kwh=m13b_q18
recode kwh 7=. 8=.
gen mbill=m13b_q21
recode mbill 9999997=. 9999998=.
replace mbill=mbill/m13b_q22

count if mbill==.

table kwh, c(m mbill med mbill n mbill)

* average values seem to be correct

* kwh<=100, it should be no more than 5000
tab mbill if kwh==1
* 100<kwh<=200, it should be between 5000 and 10000
tab mbill if kwh==2 
* 200<kwh<=300, it should be between 10000 and 15000
tab mbill if kwh==3
* 300<kwh<=400, it should be between 15000 and 24600
tab mbill if kwh==4
* 400<kwh<=500, it should be between 24600 and 34200
tab mbill if kwh==5
* kwh>500, it should be more than 34200
tab mbill if kwh==6

* we are in a difficult situation if we want to make changes, should we believe in values or in quantities (we leave them as they are for now)

* After checking the questionnaire, we correct for errors in values
replace mbill=21000 if hhid==206
replace mbill=20000 if hhid==2806
replace mbill=5600 if hhid==4906
replace mbill=6800 if hhid==5308
replace mbill=8000 if hhid==14801
replace mbill=14000 if hhid==20505
replace mbill=15000 if hhid==26303
replace mbill=20000 if hhid==27601
replace mbill=25000 if hhid==31107
replace mbill=5000 if hhid==34608
replace mbill=37000 if hhid==38801
replace mbill=17000 if hhid==39007
replace mbill=27000 if hhid==39010
replace mbill=35000 if hhid==39309
replace mbill=150000 if hhid==49409

* we believe the bills to be more reliable than quantities, so we adjust for intervals (quantities).
gen kwhadj=.
replace kwhadj=1 if mbill>=0 & mbill<=4500
replace kwhadj=2 if mbill>4500 & mbill<=9000
replace kwh=3 if mbill>9000 & mbill<=18000
replace kwh=4 if mbill>18000 & mbill<=27000
replace kwh=5 if mbill>27000 & mbill<=36000
replace kwh=6 if mbill>36000

gen arrear= m13b_q23
recode arrear 2=0
gen arvalue=m13b_q24
recode arvalue 9999997=. 9999998=.
count if m13b_q25==. & arvalue!=.
table m13b_q25, c(m arvalue n arvalue)
gen areasq=m13a_q07
recode areasq 7=.

gen elect=0 if m13b_q12f==1
recode urbrur 2=0

sum kwh kwhadj arrear arvalue m13b_q25 m13b_q12a-m13b_q12e areasq hhsize if elect==.

* if we assume that the expenditure for electricity is more or less stable each month then the last bill reported is a good estimate
* and some missing values can be inputed considering use of electricity, quantity range consumed, house size

xi: reg mbill kwhadj m13b_q12a-m13b_q12e areasq hhsize urbrur i.district if elect==.
predict est, xb
sum mbill est

tab est if mbill==.

xi: reg mbill m13b_q12a-m13b_q12e areasq hhsize urbrur i.district if elect==.
predict est1, xb
sum mbill est1

tab est1 if mbill==. & est==.

xi: reg mbill m13b_q12a-m13b_q12e hhsize urbrur i.district if elect==.
predict est2, xb
sum mbill est2

tab est2 if mbill==. & est==. & est1==.

gen estbiladj=est
replace estbiladj=est1 if estbiladj==.
replace estbiladj=est2 if estbiladj==.

gen mbillar=.
replace mbillar=arvalue/3 if m13b_q25==1
replace mbillar=arvalue/5 if m13b_q25==2
replace mbillar=arvalue/9 if m13b_q25==3
replace mbillar=arvalue/18 if m13b_q25==4

replace elect=mbill if elect==.
replace elect=est if elect==.
replace elect=mbillar if elect==.
replace elect=est1 if elect==.
replace elect=est2 if elect==.

count if elect==.

* Replacing plausible outlier cases for electricity (exceeding 65000) with the median value of 13597
egen medelect=median(elect), by(urbrur)
replace elect=medelect if elect>65000

table area [pw=weight], c(m elect)  
keep hhid elect estbiladj mbill areasq urbrur
sort hhid
save "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\electricity.dta", replace


**************************************
*****                            *****
*****           GAS              *****
*****                            *****
**************************************

/* cylinder where the capacity of the cylinder was reported only in the questionnaire were checked and include in a separate file that is merged with the original one 
use results\hhidofother, clear
sort hhid
save, replace */

use "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\dwelling_cljm.dta", clear
sort hhid

/* merge hhid using results\hhidofother
tab _merge
drop _merge */


/* 

gen gas=1 if m3b_q33==1
recode gas .=0

* we have type of cilinder (quantity) 

tab m3b_q35
tab m3b_q35, nol
table m3b_q35, c(m m3b_q36 med m3b_q36)
tab m3b_q36 if m3b_q35==4
tab m3b_q36 if m3b_q35==3
tab m3b_q36 if m3b_q35==2
tab m3b_q36 if m3b_q35==1

recode m3b_q36 99997=.
gen value=m3b_q36
gen quant=10 if m3b_q35==1
replace quant=15 if m3b_q35==2
replace quant=20 if m3b_q35==3
replace quant=quantity if m3b_q35==4
gen gelect=m3b_q34_1
gen gheat=m3b_q34_2
gen gcook=m3b_q34_3
gen gother=m3b_q34_4

gen perioda=m3b_q37a
gen periodb=m3b_q37b

* the approach should be to fix price according to quantity and then divide by period of use, distinguishing by summer and winter

table quant, c(m value med value n value)

gen value1=quant*100
* now we consider what is the period of consumption, we make the following adjustment
recode perioda 1=0.5 2=1.5 3=2.5 4=4
recode periodb 1=0.5 2=1.5 3=2.5 4=4 5=0
gen wmonths=6/12
gen smonths=6/12
gen winter=wmonths*(value1/perioda)
gen summer=smonths*(value1/periodb)

egen gascons=rsum(winter summer)
replace gascons=0 if gas==0

keep hhid gascons
sort hhid
save "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\temp3", replace 

*/


***********************************************
* 2005 Calculations
***********************************************
 * we have no data on cylinders however, we are given monthly expense for gas
 *there are no households that report to use gas, but don't report a monthly value
count if m13b_q28==1 & m13b_q30==. 
gen gas=1 if m13b_q28==1
recode gas .=0
gen gascons=m13b_q30
replace gascons=5000 if hhid==24004
replace gascons=5000 if hhid==24908
replace gascons=5000 if hhid==41809
replace gascons=5000 if hhid==46903

replace gascons=0 if gas==0
keep hhid gascons 
sort hhid
save "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\gas.dta", replace


**************************************
*****                            *****
*****           OTHER            *****
*****                            *****
**************************************

use "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\dwelling_cljm.dta", clear

sort hhid
merge hhid using "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\JMbase.dta"
tab _merge
drop _merge

* we want to have an idea of what are the sources used by household for 1) lighting, 2) heating 3) cooking
gen heat_s=m13b_q11
label val heat_s M13B_Q11
tab heat_s

gen heatsource=1 if  m13b_q12b==1 & m13b_q29b!=1
replace heatsource=2 if m13b_q29b==1 & m13b_q12b!=1
replace heatsource=3 if m13b_q29b==1 & m13b_q12b==1
replace heatsource=0 if m13b_q29b!=1 & m13b_q12b!=1
lab def use 0 "no gas no elect"
lab def use 1 "only elect", add
lab def use 2 "only gas", add
lab def use 3 "both gas and elect", add
lab val heatsource use

* no data was provided for centra heating therefore heatsource from central heating was ignored

tab heatsource heat_s

gen light_s=m13b_q27
label val light_s M13B_Q27
gen lightsource=1 if m13b_q12a==1 & m13b_q29a!=1 
replace lightsource=2 if m13b_q29a==1 & m13b_q12a!=1
replace lightsource=3 if m13b_q29a==1 & m13b_q12a==1
replace lightsource=0 if m13b_q29a!=1 & m13b_q12a!=1
lab val lightsource use

tab lightsource light_s

gen cooksource=1 if m13b_q12c==1 & m13b_q29c!=1 
replace cooksource=2 if m13b_q29c==1 & m13b_q12c!=1
replace cooksource=3 if m13b_q29c==1 & m13b_q12c==1
replace cooksource=0 if m13b_q29c!=1 & m13b_q12c!=1
lab val cooksource use

gen f_heat=1 if heat_s==2
gen c_heat=1 if heat_s==5
gen k_heat=1 if heat_s==4
gen o_heat=1 if heat_s==8
gen k_light=1 if light_s==2 | light_s==1
gen o_light=1 if light_s==4
for var f_heat-o_light: recode X .=0

* Other products used for heating and lighting (firewood, coal, oil, diesel, other)

gen firew_w=1 if m13b_q31a_1>0 & m13b_q31a_1!=.
gen firew_s=1 if m13b_q31a_2>0 & m13b_q31a_2!=.
gen coal_w=1 if m13b_q31b_1>0 & m13b_q31b_1!=.
gen coal_s=1 if m13b_q31b_2>0 & m13b_q31b_2!=.
gen oil_w=1 if m13b_q31c_1>0 & m13b_q31c_1!=.
gen oil_s=1 if m13b_q31c_2>0 & m13b_q31c_2!=.
gen dies_w=1 if m13b_q31d_1>0 & m13b_q31d_1!=.
gen dies_s=1 if m13b_q31d_2>0 & m13b_q31d_2!=.
gen other_w=1 if m13b_q31e_1>0 & m13b_q31e_1!=.
gen other_s=1 if m13b_q31e_2>0 & m13b_q31e_2!=.
for var m13b_q31a_1-m13b_q31e_2: recode X 99997=.

gen vfirew_w=m13b_q31a_1
gen vfirew_s=m13b_q31a_2
gen vcoal_w=m13b_q31b_1
gen vcoal_s=m13b_q31b_2
gen voil_w=m13b_q31c_1
gen voil_s=m13b_q31c_2
gen vdies_w=m13b_q31d_1
gen vdies_s=m13b_q31d_2
gen vother_w=m13b_q31e_1
gen vother_s=m13b_q31e_2

* we expect that winter months are 6 and summer months 6
gen wmonths=6/12
gen smonths=6/12

*** firewood

*** we substitiute missing with values in the same psu where household use the source in the same way.
* winter
tab heatsource firew_w
tab heat_s firew_w
count if firew_w==1 & vfirew_w==.
tab f_heat if firew_w==1 & vfirew_w==.
tab heatsource if firew_w==1 & vfirew_w==.

* Those who use firewood for heating, but not gas or electricity
gen tobeused=vfirew_w if f_heat==1 & heatsource==0
egen medfire1=median(tobeused), by(psu)
tab medfire1 if firew_w==1 & vfirew_w==. & heatsource==0
replace vfirew_w=medfire1 if firew_w==1 & vfirew_w==. & heatsource==0
egen medfire2=median(tobeused), by(district)
tab medfire2 if firew_w==1 & vfirew_w==. & heatsource==0
replace vfirew_w=medfire2 if firew_w==1 & vfirew_w==. & heatsource==0
drop tobeused medfire1 medfire2

* Those who use firewood for heating and electricity
gen tobeused=vfirew_w if f_heat==1 & heatsource==1
egen medfire1=median(tobeused), by(psu)
replace vfirew_w=medfire1 if firew_w==1 & vfirew_w==. & heatsource==1
egen medfire2=median(tobeused), by(district)
replace vfirew_w=medfire2 if firew_w==1 & vfirew_w==. & heatsource==1
egen medfire3=median(tobeused)
replace vfirew_w=medfire3 if firew_w==1 & vfirew_w==. & heatsource==1
drop tobeused medfire1 medfire2 medfire3
count if firew_w==1 & vfirew_w==.

* summer
tab heatsource firew_s
tab heat_s firew_s
count if firew_s==1 & vfirew_s==.
tab f_heat if firew_s==1 & vfirew_s==.
tab heatsource if firew_s==1 & vfirew_s==.

* Those who use only firewood for heating
gen tobeused=vfirew_s if f_heat==1 & heatsource==0
egen medfire1=median(tobeused), by(psu)
replace vfirew_s=medfire1 if firew_s==1 & vfirew_s==. & heatsource==0
egen medfire2=median(tobeused), by(district)
replace vfirew_s=medfire2 if firew_s==1 & vfirew_s==. & heatsource==0
drop tobeused medfire1 medfire2

* Those who use firewood as well electricity for heating
gen tobeused=vfirew_s if f_heat==1 & heatsource==1
egen medfire1=median(tobeused), by(psu)
replace vfirew_s=medfire1 if firew_s==1 & vfirew_s==. & heatsource==1
egen medfire2=median(tobeused), by(district)
replace vfirew_s=medfire2 if firew_s==1 & vfirew_s==. & heatsource==1
egen medfire3=median(tobeused)
replace vfirew_s=medfire3 if firew_s==1 & vfirew_s==. & heatsource==1
drop tobeused medfire1 medfire2 medfire3
count if firew_s==1 & vfirew_s==.

gen firewoodw=wmonths*vfirew_w
gen firewoods=smonths*vfirew_s
egen firewood=rsum(firewoodw firewoods)
drop firewoodw firewoods

egen totfire=rsum(vfirew_w vfirew_s)

* it seems that there are some problems with firewood, some household reported the season expenditure instead of the monthly one
* we correct assuming that whenever households report an expenditure above 40000 they refer to annual expenditure
drop firewood
gen firewood=totfire/2 if totfire<=40000
replace firewood=totfire/12 if totfire>40000

*** coal

* winter and summer
tab heatsource coal_w
tab heat_s coal_w
count if coal_w==1 & vcoal_w==.
tab heatsource coal_s
tab heat_s coal_s
count if coal_s==1 & vcoal_s==.
gen coalw=wmonths*vcoal_w
gen coals=smonths*vcoal_s
egen coal=rsum(coalw coals)
drop coalw coals


*** oil, kerosene (no need to adjust for new money since all money is in old money)

tab heatsource oil_w
tab heat_s oil_w
count if oil_w==1 & voil_w==.
tab heatsource if oil_w==1 & voil_w==.
tab k_heat if oil_w==1 & voil_w==.

* Those who use kerosene for heating and electricity
gen tobeused=voil_w if k_heat==1 & heatsource==1
tab tobeused
egen medoil=median(tobeused)
replace voil_w=medoil if oil_w==1 & voil_w==.
drop tobeused medoil

tab heatsource oil_s
tab heat_s oil_s
count if oil_s==1 & voil_s==.
tab heatsource if oil_s==1 & voil_s==.
tab k_heat if oil_s==1 & voil_s==.
gen tobeused=voil_s if k_heat==1 & heatsource==1
tab tobeused
egen medoil=median(tobeused)
replace voil_s=medoil if oil_s==1 & voil_s==.
drop tobeused medoil

gen oilw=wmonths*voil_w
gen oils=smonths*voil_s
egen oilker=rsum(oilw oils)
drop oilw oils

*** diesel 

tab heatsource dies_w
tab heat_s dies_w
count if dies_w==1 & vdies_w==.
tab heatsource dies_s
tab heat_s dies_s
count if dies_s==1 & vdies_s==.
gen diesw=wmonths*vdies_w
gen diess=smonths*vdies_s
egen diesel=rsum(diesw diess)
drop diesw diess

*** other

tab heatsource other_w
tab heat_s other_w
tab lightsource other_w
tab light_s other_w
count if other_w==1 & vother_w==.
tab heatsource if other_w==1 & vother_w==.
tab heat_s if other_w==1 & vother_w==.
tab lightsource if other_w==1 & vother_w==.
tab light_s if other_w==1 & vother_w==.
replace vother_w=0 if other_w==1 & vother_w==.
tab heatsource other_s
tab heat_s other_s
count if other_s==1 & vother_s==.

gen otherw=wmonths*vother_w
gen others=smonths*vother_s
egen other=rsum(otherw others)
drop otherw others

*** central heating could not be generated since there were no data for central heating

*** telephone

tab m13b_q32
gen telephone=1 if m13b_q33==1
gen phonebill=m13b_q34
replace phonebill=phonebill/m13b_q35
label var phonebill "Total amount paid by household in phone bills (fixed line)"

*** mobile
gen mobile=m3_q14
label var m3_q14 "total amount paid by household in mobile charges"


* ther are no data on public phone

* After checking the questionnaire, noted that high values are households with multiple users
* who have also businesses. 

*** computer
tab m13b_q36
gen computer=1 if m13b_q40==1
gen computerbill=m13b_q41

* replacing plausible outlier cases for computer expenses with the median value of 20000.
replace computerbill=20000 if computerbill>70000 & computerbill!=.

* no need to impute values since the ones declared to pay for the service have actually paid
count if m13b_q40==1 & computerbill==.

for var firewood coal oilker diesel other mobile phonebill computerbill: recode X .=0
sum firewood coal oilker diesel other mobile phonebill computerbill 
keep hhid firewood coal oilker diesel other mobile phonebill computerbill 
sort hhid
save "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\other.dta", replace
drop _all

**************************************
*****                            *****
*****        ALL TOGETHER        *****
*****                            *****
**************************************

use "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\water.dta", clear
sort hhid
merge hhid using "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\electricity.dta" 
tab _merge
drop _merge
sort hhid
merge hhid using "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\gas.dta"
tab _merge
drop _merge
sort hhid
merge hhid using "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\other.dta" 
tab _merge
drop _merge
sort hhid
gen year=2005
sort hhid
egen totutil= rsum(firewood coal oilker diesel other mobile phonebill computerbill gascons waterb elect)
egen totutil2= rsum(firewood coal oilker diesel other mobile phonebill gascons waterb elect)

* Corrections to households incorrectly coded
replace hhid=509 if hhid==505
replace hhid=1502 if hhid==1505
replace hhid=2310 if hhid==2309
replace hhid=6902 if hhid==6901
replace hhid=8708 if hhid==8709
replace hhid=9308 if hhid==9309
replace hhid=16109 if hhid==16110
replace hhid=18210 if hhid==18211
replace hhid=23007 if hhid==23001
replace hhid=26009 if hhid==26010
replace hhid=26509 if hhid==26510
replace hhid=34210 if hhid==34206
replace hhid=34409 if hhid==34402
replace hhid=37507 if hhid==37506
replace hhid=41609 if hhid==41608
replace hhid=43211 if hhid==43201
replace hhid=44506 if hhid==44505
replace hhid=46411 if hhid==46410
sort hhid
save "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 padata\utilitiesjm.dta", replace

!del "C:\Documents and Settings\wb178469\My Documents\Albania\LSMS 2005 tempdata\basejm*.dta"

drop _all
log close

